<?php
namespace GopNext\Services;

class OperatingBudgetParametersService{
    
    public function __construct($entityManager, $environment){
        $this->connection = $entityManager->getConnection();
        $this->environment = $environment;
   }
   
    public function beginTransaction() {
        $this->connection->beginTransaction();
    }
    
    public function commit() {
        $this->connection->commit();
    }
    
    public function rollback() {
      $this->connection->rollback();
    }
   
    public function reciveParametersForBudgetOperation(){
        $query = "SELECT * FROM PARAMORCAOPERAC";
        try {
            $std = $this->connection->prepare($query);
            $std->execute();
            $result = $std->fetchAll();
            return $result;
        } catch (Exception $e) {
            throw $e;
        }
    }
    
        public function updateBudgetOperation($params) {
        $query = 
        "UPDATE PARAMORCAOPERAC
            SET
                IDTIPOSIMULARESULTFAT = :IDTIPOSIMULARESULTFAT,
                IDUTILMESBASE = :IDUTILMESBASE,
                CDTIPOCUSTO = :CDTIPOCUSTO,
                CDTOINDICECON = :CDTOINDICECON,
                CDINDICEFAT = :CDINDICEFAT,
                IDORCDESPDIVERS = :IDORCDESPDIVERS,
                IDORCADESPMATRI = :IDORCADESPMATRI,
                IDORCDESPENTROP = :IDORCDESPENTROP,
                NRDIALIMITEORCA = :NRDIALIMITEORCA,
                IDPERORCAITEMDETAL = :IDPERORCAITEMDETAL,
                IDUTILVERSAOORCA = :IDUTILVERSAOORCA,
                IDAPROVORCACONC = :IDAPROVORCACONC,
                IDCALCFATUROP = :IDCALCFATUROP,
                NRDIAANTELABORCA = :NRDIAANTELABORCA,
                IDUTILORCAREALOC = :IDUTILORCAREALOC,
                IDCONSORCREALOC = :IDCONSORCREALOC,
                IDPERIODOORCA = :IDPERIODOORCA,
                IDREALINFORCA = :IDREALINFORCA,
                IDREALSUPORCA = :IDREALSUPORCA,
                NRDIAINIORCA = :NRDIAINIORCA,
                NRMESINIORCA = :NRMESINIORCA
            WHERE
                CDPARORCAOPERAC = '00001'";
            
        try {
            $std = $this->connection->prepare($query);
            $std->execute($params);
        } catch (Exception $e){
            throw $e;
        };
    }

    public function insertOperationalItem($params) {
        $query =
            " INSERT INTO ITEMOPERACIONAL (
                NRITEMOPERACIONAL,
                IDTIPOORCAOP,
                IDCHECK
            ) VALUES (
                :NRITEMOPERACIONAL,
                :IDTIPOORCAOP,
                :IDCHECK)";
        try{
            $std = $this->connection->prepare($query);
            $std->execute($params);
        }catch(Exception $e) {
            throw $e;
        }
    }
}